From: Angus Ainslie <angus@akkea.ca>
Date: Mon, 24 May 2021 12:52:48 -0700
Subject: net: wireless: redpine: can't use BT dual on newer firmwares

Firmware 2.0024 broke BLE

Signed-off-by: Angus Ainslie <angus@akkea.ca>
---
 drivers/net/wireless/redpine/rsi_91x_hal.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/drivers/net/wireless/redpine/rsi_91x_hal.c b/drivers/net/wireless/redpine/rsi_91x_hal.c
index 0e0ce04..06008ff 100644
--- a/drivers/net/wireless/redpine/rsi_91x_hal.c
+++ b/drivers/net/wireless/redpine/rsi_91x_hal.c
@@ -1819,9 +1819,14 @@ static int rsi_load_firmware(struct rsi_hw *adapter)
 int rsi_validate_oper_mode(u16 oper_mode)
 {
 #if defined(CONFIG_RS9116_PURISM)
-	if ((oper_mode == 13) || (oper_mode == 14))
+	if ((oper_mode == 5) || (oper_mode == 6))
 		return 0;
-	else {
+	if ((oper_mode == 13) || (oper_mode == 14)) {
+		redpine_dbg(ERR_ZONE,
+				"Operating mode %d is only supported prior to firmware 2.x\n",
+				oper_mode);
+		return 0;
+	} else {
 		redpine_dbg(ERR_ZONE,
 				"Operating mode %d is not supported, "
 				"it should be either 13 or 14\n",
